bc20185b51ba85db9f12659096b5ca859206ca35
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29else
  30        # ensure that TEST_DIRECTORY is an absolute path so that it
  31        # is valid even if the current working directory is changed
  32        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  33fi
  34if test -z "$TEST_OUTPUT_DIRECTORY"
  35then
  36        # Similarly, override this to store the test-results subdir
  37        # elsewhere
  38        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  39fi
  40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  41
  42################################################################
  43# It appears that people try to run tests without building...
  44"$GIT_BUILD_DIR/git" >/dev/null
  45if test $? != 1
  46then
  47        echo >&2 'error: you do not seem to have built git yet.'
  48        exit 1
  49fi
  50
  51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  52export PERL_PATH SHELL_PATH
  53
  54# if --tee was passed, write the output not only to the terminal, but
  55# additionally to the file test-results/$BASENAME.out, too.
  56case "$GIT_TEST_TEE_STARTED, $* " in
  57done,*)
  58        # do not redirect again
  59        ;;
  60*' --tee '*|*' --va'*)
  61        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  62        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  63        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  64         echo $? > $BASE.exit) | tee $BASE.out
  65        test "$(cat $BASE.exit)" = 0
  66        exit
  67        ;;
  68esac
  69
  70# For repeatability, reset the environment to known value.
  71LANG=C
  72LC_ALL=C
  73PAGER=cat
  74TZ=UTC
  75TERM=dumb
  76export LANG LC_ALL PAGER TERM TZ
  77EDITOR=:
  78# A call to "unset" with no arguments causes at least Solaris 10
  79# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  80# deriving from the command substitution clustered with the other
  81# ones.
  82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  83        my @env = keys %ENV;
  84        my $ok = join("|", qw(
  85                TRACE
  86                DEBUG
  87                USE_LOOKUP
  88                TEST
  89                .*_TEST
  90                PROVE
  91                VALGRIND
  92                UNZIP
  93                PERF_
  94                CURL_VERBOSE
  95        ));
  96        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  97        print join("\n", @vars);
  98')
  99unset XDG_CONFIG_HOME
 100unset GITPERLLIB
 101GIT_AUTHOR_EMAIL=author@example.com
 102GIT_AUTHOR_NAME='A U Thor'
 103GIT_COMMITTER_EMAIL=committer@example.com
 104GIT_COMMITTER_NAME='C O Mitter'
 105GIT_MERGE_VERBOSITY=5
 106GIT_MERGE_AUTOEDIT=no
 107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 110export EDITOR
 111
 112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 113GIT_TRACE_BARE=1
 114export GIT_TRACE_BARE
 115
 116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 117then
 118        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 119        export GIT_INDEX_VERSION
 120fi
 121
 122# Add libc MALLOC and MALLOC_PERTURB test
 123# only if we are not executing the test with valgrind
 124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 125   test -n "$TEST_NO_MALLOC_CHECK"
 126then
 127        setup_malloc_check () {
 128                : nothing
 129        }
 130        teardown_malloc_check () {
 131                : nothing
 132        }
 133else
 134        setup_malloc_check () {
 135                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 136                export MALLOC_CHECK_ MALLOC_PERTURB_
 137        }
 138        teardown_malloc_check () {
 139                unset MALLOC_CHECK_ MALLOC_PERTURB_
 140        }
 141fi
 142
 143: ${ASAN_OPTIONS=detect_leaks=0}
 144export ASAN_OPTIONS
 145
 146# Protect ourselves from common misconfiguration to export
 147# CDPATH into the environment
 148unset CDPATH
 149
 150unset GREP_OPTIONS
 151unset UNZIP
 152
 153case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1541|2|true)
 155        echo "* warning: Some tests will not work if GIT_TRACE" \
 156                "is set as to trace on STDERR ! *"
 157        echo "* warning: Please set GIT_TRACE to something" \
 158                "other than 1, 2 or true ! *"
 159        ;;
 160esac
 161
 162# Convenience
 163#
 164# A regexp to match 5 and 40 hexdigits
 165_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 166_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 167
 168# Zero SHA-1
 169_z40=0000000000000000000000000000000000000000
 170
 171# Line feed
 172LF='
 173'
 174
 175# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 176# when case-folding filenames
 177u200c=$(printf '\342\200\214')
 178
 179export _x05 _x40 _z40 LF u200c
 180
 181# Each test should start with something like this, after copyright notices:
 182#
 183# test_description='Description of this test...
 184# This test checks if command xyzzy does the right thing...
 185# '
 186# . ./test-lib.sh
 187
 188unset color
 189while test "$#" -ne 0
 190do
 191        case "$1" in
 192        -d|--d|--de|--deb|--debu|--debug)
 193                debug=t; shift ;;
 194        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 195                immediate=t; shift ;;
 196        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 197                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 198        -r)
 199                shift; test "$#" -ne 0 || {
 200                        echo 'error: -r requires an argument' >&2;
 201                        exit 1;
 202                }
 203                run_list=$1; shift ;;
 204        --run=*)
 205                run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
 206        -h|--h|--he|--hel|--help)
 207                help=t; shift ;;
 208        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 209                verbose=t; shift ;;
 210        --verbose-only=*)
 211                verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 212                shift ;;
 213        -q|--q|--qu|--qui|--quie|--quiet)
 214                # Ignore --quiet under a TAP::Harness. Saying how many tests
 215                # passed without the ok/not ok details is always an error.
 216                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 217        --with-dashes)
 218                with_dashes=t; shift ;;
 219        --no-color)
 220                color=; shift ;;
 221        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 222                valgrind=memcheck
 223                shift ;;
 224        --valgrind=*)
 225                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 226                shift ;;
 227        --valgrind-only=*)
 228                valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 229                shift ;;
 230        --tee)
 231                shift ;; # was handled already
 232        --root=*)
 233                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 234                shift ;;
 235        --chain-lint)
 236                GIT_TEST_CHAIN_LINT=1
 237                shift ;;
 238        --no-chain-lint)
 239                GIT_TEST_CHAIN_LINT=0
 240                shift ;;
 241        -x)
 242                trace=t
 243                verbose=t
 244                shift ;;
 245        *)
 246                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 247        esac
 248done
 249
 250if test -n "$valgrind_only"
 251then
 252        test -z "$valgrind" && valgrind=memcheck
 253        test -z "$verbose" && verbose_only="$valgrind_only"
 254elif test -n "$valgrind"
 255then
 256        verbose=t
 257fi
 258
 259error () {
 260        say_color error "error: $*"
 261        GIT_EXIT_OK=t
 262        exit 1
 263}
 264
 265say () {
 266        say_color info "$*"
 267}
 268
 269test "${test_description}" != "" ||
 270error "Test script did not set test_description."
 271
 272if test "$help" = "t"
 273then
 274        printf '%s\n' "$test_description"
 275        exit 0
 276fi
 277
 278exec 5>&1
 279exec 6<&0
 280if test "$verbose" = "t"
 281then
 282        exec 4>&2 3>&1
 283else
 284        exec 4>/dev/null 3>/dev/null
 285fi
 286
 287test_failure=0
 288test_count=0
 289test_fixed=0
 290test_broken=0
 291test_success=0
 292
 293test_external_has_tap=0
 294
 295die () {
 296        code=$?
 297        if test -n "$GIT_EXIT_OK"
 298        then
 299                exit $code
 300        else
 301                echo >&5 "FATAL: Unexpected exit with code $code"
 302                exit 1
 303        fi
 304}
 305
 306GIT_EXIT_OK=
 307trap 'die' EXIT
 308
 309# The user-facing functions are loaded from a separate file so that
 310# test_perf subshells can have them too
 311. "$TEST_DIRECTORY/test-lib-functions.sh"
 312
 313# You are not expected to call test_ok_ and test_failure_ directly, use
 314# the test_expect_* functions instead.
 315
 316test_ok_ () {
 317        test_success=$(($test_success + 1))
 318        say_color "" "ok $test_count - $@"
 319}
 320
 321test_failure_ () {
 322        test_failure=$(($test_failure + 1))
 323        say_color error "not ok $test_count - $1"
 324        shift
 325        printf '%s\n' "$*" | sed -e 's/^/#      /'
 326        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 327}
 328
 329test_known_broken_ok_ () {
 330        test_fixed=$(($test_fixed+1))
 331        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 332}
 333
 334test_known_broken_failure_ () {
 335        test_broken=$(($test_broken+1))
 336        say_color warn "not ok $test_count - $@ # TODO known breakage"
 337}
 338
 339test_debug () {
 340        test "$debug" = "" || eval "$1"
 341}
 342
 343match_pattern_list () {
 344        arg="$1"
 345        shift
 346        test -z "$*" && return 1
 347        for pattern_
 348        do
 349                case "$arg" in
 350                $pattern_)
 351                        return 0
 352                esac
 353        done
 354        return 1
 355}
 356
 357match_test_selector_list () {
 358        title="$1"
 359        shift
 360        arg="$1"
 361        shift
 362        test -z "$1" && return 0
 363
 364        # Both commas and whitespace are accepted as separators.
 365        OLDIFS=$IFS
 366        IFS='   ,'
 367        set -- $1
 368        IFS=$OLDIFS
 369
 370        # If the first selector is negative we include by default.
 371        include=
 372        case "$1" in
 373                !*) include=t ;;
 374        esac
 375
 376        for selector
 377        do
 378                orig_selector=$selector
 379
 380                positive=t
 381                case "$selector" in
 382                        !*)
 383                                positive=
 384                                selector=${selector##?}
 385                                ;;
 386                esac
 387
 388                test -z "$selector" && continue
 389
 390                case "$selector" in
 391                        *-*)
 392                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 393                                then
 394                                        echo "error: $title: invalid non-numeric in range" \
 395                                                "start: '$orig_selector'" >&2
 396                                        exit 1
 397                                fi
 398                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 399                                then
 400                                        echo "error: $title: invalid non-numeric in range" \
 401                                                "end: '$orig_selector'" >&2
 402                                        exit 1
 403                                fi
 404                                ;;
 405                        *)
 406                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 407                                then
 408                                        echo "error: $title: invalid non-numeric in test" \
 409                                                "selector: '$orig_selector'" >&2
 410                                        exit 1
 411                                fi
 412                esac
 413
 414                # Short cut for "obvious" cases
 415                test -z "$include" && test -z "$positive" && continue
 416                test -n "$include" && test -n "$positive" && continue
 417
 418                case "$selector" in
 419                        -*)
 420                                if test $arg -le ${selector#-}
 421                                then
 422                                        include=$positive
 423                                fi
 424                                ;;
 425                        *-)
 426                                if test $arg -ge ${selector%-}
 427                                then
 428                                        include=$positive
 429                                fi
 430                                ;;
 431                        *-*)
 432                                if test ${selector%%-*} -le $arg \
 433                                        && test $arg -le ${selector#*-}
 434                                then
 435                                        include=$positive
 436                                fi
 437                                ;;
 438                        *)
 439                                if test $arg -eq $selector
 440                                then
 441                                        include=$positive
 442                                fi
 443                                ;;
 444                esac
 445        done
 446
 447        test -n "$include"
 448}
 449
 450maybe_teardown_verbose () {
 451        test -z "$verbose_only" && return
 452        exec 4>/dev/null 3>/dev/null
 453        verbose=
 454}
 455
 456last_verbose=t
 457maybe_setup_verbose () {
 458        test -z "$verbose_only" && return
 459        if match_pattern_list $test_count $verbose_only
 460        then
 461                exec 4>&2 3>&1
 462                # Emit a delimiting blank line when going from
 463                # non-verbose to verbose.  Within verbose mode the
 464                # delimiter is printed by test_expect_*.  The choice
 465                # of the initial $last_verbose is such that before
 466                # test 1, we do not print it.
 467                test -z "$last_verbose" && echo >&3 ""
 468                verbose=t
 469        else
 470                exec 4>/dev/null 3>/dev/null
 471                verbose=
 472        fi
 473        last_verbose=$verbose
 474}
 475
 476maybe_teardown_valgrind () {
 477        test -z "$GIT_VALGRIND" && return
 478        GIT_VALGRIND_ENABLED=
 479}
 480
 481maybe_setup_valgrind () {
 482        test -z "$GIT_VALGRIND" && return
 483        if test -z "$valgrind_only"
 484        then
 485                GIT_VALGRIND_ENABLED=t
 486                return
 487        fi
 488        GIT_VALGRIND_ENABLED=
 489        if match_pattern_list $test_count $valgrind_only
 490        then
 491                GIT_VALGRIND_ENABLED=t
 492        fi
 493}
 494
 495# This is a separate function because some tests use
 496# "return" to end a test_expect_success block early
 497# (and we want to make sure we run any cleanup like
 498# "set +x").
 499test_eval_inner_ () {
 500        # Do not add anything extra (including LF) after '$*'
 501        eval "
 502                test \"$trace\" = t && set -x
 503                $*"
 504}
 505
 506test_eval_ () {
 507        # We run this block with stderr redirected to avoid extra cruft
 508        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 509        # the shell from printing the "set +x" to turn it off (nor the saving
 510        # of $? before that). But we can make sure that the output goes to
 511        # /dev/null.
 512        #
 513        # The test itself is run with stderr put back to &4 (so either to
 514        # /dev/null, or to the original stderr if --verbose was used).
 515        {
 516                test_eval_inner_ "$@" </dev/null >&3 2>&4
 517                test_eval_ret_=$?
 518                if test "$trace" = t
 519                then
 520                        set +x
 521                        if test "$test_eval_ret_" != 0
 522                        then
 523                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 524                        fi
 525                fi
 526        } 2>/dev/null
 527        return $test_eval_ret_
 528}
 529
 530test_run_ () {
 531        test_cleanup=:
 532        expecting_failure=$2
 533
 534        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 535                # turn off tracing for this test-eval, as it simply creates
 536                # confusing noise in the "-x" output
 537                trace_tmp=$trace
 538                trace=
 539                # 117 is magic because it is unlikely to match the exit
 540                # code of other programs
 541                test_eval_ "(exit 117) && $1"
 542                if test "$?" != 117; then
 543                        error "bug in the test script: broken &&-chain: $1"
 544                fi
 545                trace=$trace_tmp
 546        fi
 547
 548        setup_malloc_check
 549        test_eval_ "$1"
 550        eval_ret=$?
 551        teardown_malloc_check
 552
 553        if test -z "$immediate" || test $eval_ret = 0 ||
 554           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 555        then
 556                setup_malloc_check
 557                test_eval_ "$test_cleanup"
 558                teardown_malloc_check
 559        fi
 560        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 561        then
 562                echo ""
 563        fi
 564        return "$eval_ret"
 565}
 566
 567test_start_ () {
 568        test_count=$(($test_count+1))
 569        maybe_setup_verbose
 570        maybe_setup_valgrind
 571}
 572
 573test_finish_ () {
 574        echo >&3 ""
 575        maybe_teardown_valgrind
 576        maybe_teardown_verbose
 577}
 578
 579test_skip () {
 580        to_skip=
 581        skipped_reason=
 582        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 583        then
 584                to_skip=t
 585                skipped_reason="GIT_SKIP_TESTS"
 586        fi
 587        if test -z "$to_skip" && test -n "$test_prereq" &&
 588           ! test_have_prereq "$test_prereq"
 589        then
 590                to_skip=t
 591
 592                of_prereq=
 593                if test "$missing_prereq" != "$test_prereq"
 594                then
 595                        of_prereq=" of $test_prereq"
 596                fi
 597                skipped_reason="missing $missing_prereq${of_prereq}"
 598        fi
 599        if test -z "$to_skip" && test -n "$run_list" &&
 600                ! match_test_selector_list '--run' $test_count "$run_list"
 601        then
 602                to_skip=t
 603                skipped_reason="--run"
 604        fi
 605
 606        case "$to_skip" in
 607        t)
 608                say_color skip >&3 "skipping test: $@"
 609                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 610                : true
 611                ;;
 612        *)
 613                false
 614                ;;
 615        esac
 616}
 617
 618# stub; perf-lib overrides it
 619test_at_end_hook_ () {
 620        :
 621}
 622
 623test_done () {
 624        GIT_EXIT_OK=t
 625
 626        if test -z "$HARNESS_ACTIVE"
 627        then
 628                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 629                mkdir -p "$test_results_dir"
 630                base=${0##*/}
 631                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 632
 633                cat >>"$test_results_path" <<-EOF
 634                total $test_count
 635                success $test_success
 636                fixed $test_fixed
 637                broken $test_broken
 638                failed $test_failure
 639
 640                EOF
 641        fi
 642
 643        if test "$test_fixed" != 0
 644        then
 645                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 646        fi
 647        if test "$test_broken" != 0
 648        then
 649                say_color warn "# still have $test_broken known breakage(s)"
 650        fi
 651        if test "$test_broken" != 0 || test "$test_fixed" != 0
 652        then
 653                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 654                msg="remaining $test_remaining test(s)"
 655        else
 656                test_remaining=$test_count
 657                msg="$test_count test(s)"
 658        fi
 659        case "$test_failure" in
 660        0)
 661                # Maybe print SKIP message
 662                if test -n "$skip_all" && test $test_count -gt 0
 663                then
 664                        error "Can't use skip_all after running some tests"
 665                fi
 666                test -z "$skip_all" || skip_all=" # SKIP $skip_all"
 667
 668                if test $test_external_has_tap -eq 0
 669                then
 670                        if test $test_remaining -gt 0
 671                        then
 672                                say_color pass "# passed all $msg"
 673                        fi
 674                        say "1..$test_count$skip_all"
 675                fi
 676
 677                test -d "$remove_trash" &&
 678                cd "$(dirname "$remove_trash")" &&
 679                rm -rf "$(basename "$remove_trash")"
 680
 681                test_at_end_hook_
 682
 683                exit 0 ;;
 684
 685        *)
 686                if test $test_external_has_tap -eq 0
 687                then
 688                        say_color error "# failed $test_failure among $msg"
 689                        say "1..$test_count"
 690                fi
 691
 692                exit 1 ;;
 693
 694        esac
 695}
 696
 697if test -n "$valgrind"
 698then
 699        make_symlink () {
 700                test -h "$2" &&
 701                test "$1" = "$(readlink "$2")" || {
 702                        # be super paranoid
 703                        if mkdir "$2".lock
 704                        then
 705                                rm -f "$2" &&
 706                                ln -s "$1" "$2" &&
 707                                rm -r "$2".lock
 708                        else
 709                                while test -d "$2".lock
 710                                do
 711                                        say "Waiting for lock on $2."
 712                                        sleep 1
 713                                done
 714                        fi
 715                }
 716        }
 717
 718        make_valgrind_symlink () {
 719                # handle only executables, unless they are shell libraries that
 720                # need to be in the exec-path.
 721                test -x "$1" ||
 722                test "# " = "$(head -c 2 <"$1")" ||
 723                return;
 724
 725                base=$(basename "$1")
 726                symlink_target=$GIT_BUILD_DIR/$base
 727                # do not override scripts
 728                if test -x "$symlink_target" &&
 729                    test ! -d "$symlink_target" &&
 730                    test "#!" != "$(head -c 2 < "$symlink_target")"
 731                then
 732                        symlink_target=../valgrind.sh
 733                fi
 734                case "$base" in
 735                *.sh|*.perl)
 736                        symlink_target=../unprocessed-script
 737                esac
 738                # create the link, or replace it if it is out of date
 739                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 740        }
 741
 742        # override all git executables in TEST_DIRECTORY/..
 743        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 744        mkdir -p "$GIT_VALGRIND"/bin
 745        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 746        do
 747                make_valgrind_symlink $file
 748        done
 749        # special-case the mergetools loadables
 750        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 751        OLDIFS=$IFS
 752        IFS=:
 753        for path in $PATH
 754        do
 755                ls "$path"/git-* 2> /dev/null |
 756                while read file
 757                do
 758                        make_valgrind_symlink "$file"
 759                done
 760        done
 761        IFS=$OLDIFS
 762        PATH=$GIT_VALGRIND/bin:$PATH
 763        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 764        export GIT_VALGRIND
 765        GIT_VALGRIND_MODE="$valgrind"
 766        export GIT_VALGRIND_MODE
 767        GIT_VALGRIND_ENABLED=t
 768        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 769        export GIT_VALGRIND_ENABLED
 770elif test -n "$GIT_TEST_INSTALLED"
 771then
 772        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 773        error "Cannot run git from $GIT_TEST_INSTALLED."
 774        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 775        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 776else # normal case, use ../bin-wrappers only unless $with_dashes:
 777        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 778        if ! test -x "$git_bin_dir/git"
 779        then
 780                if test -z "$with_dashes"
 781                then
 782                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 783                fi
 784                with_dashes=t
 785        fi
 786        PATH="$git_bin_dir:$PATH"
 787        GIT_EXEC_PATH=$GIT_BUILD_DIR
 788        if test -n "$with_dashes"
 789        then
 790                PATH="$GIT_BUILD_DIR:$PATH"
 791        fi
 792fi
 793GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 794GIT_CONFIG_NOSYSTEM=1
 795GIT_ATTR_NOSYSTEM=1
 796export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 797
 798if test -z "$GIT_TEST_CMP"
 799then
 800        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 801        then
 802                GIT_TEST_CMP="$DIFF -c"
 803        else
 804                GIT_TEST_CMP="$DIFF -u"
 805        fi
 806fi
 807
 808GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 809export GITPERLLIB
 810test -d "$GIT_BUILD_DIR"/templates/blt || {
 811        error "You haven't built things yet, have you?"
 812}
 813
 814if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 815then
 816        echo >&2 'You need to build test-chmtime:'
 817        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 818        exit 1
 819fi
 820
 821# Test repository
 822TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 823test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 824case "$TRASH_DIRECTORY" in
 825/*) ;; # absolute path is good
 826 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 827esac
 828test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 829rm -fr "$TRASH_DIRECTORY" || {
 830        GIT_EXIT_OK=t
 831        echo >&5 "FATAL: Cannot prepare test area"
 832        exit 1
 833}
 834
 835HOME="$TRASH_DIRECTORY"
 836GNUPGHOME="$HOME/gnupg-home-not-used"
 837export HOME GNUPGHOME
 838
 839# run the tput tests *after* changing HOME (in case ncurses needs
 840# ~/.terminfo for $TERM)
 841test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
 842                TERM=$ORIGINAL_TERM &&
 843                export TERM &&
 844                test -t 1 &&
 845                tput bold >/dev/null 2>&1 &&
 846                tput setaf 1 >/dev/null 2>&1 &&
 847                tput sgr0 >/dev/null 2>&1
 848        ) &&
 849        color=t
 850
 851if test -n "$color"
 852then
 853        say_color () {
 854                (
 855                TERM=$ORIGINAL_TERM
 856                export TERM
 857                case "$1" in
 858                error)
 859                        tput bold; tput setaf 1;; # bold red
 860                skip)
 861                        tput setaf 4;; # blue
 862                warn)
 863                        tput setaf 3;; # brown/yellow
 864                pass)
 865                        tput setaf 2;; # green
 866                info)
 867                        tput setaf 6;; # cyan
 868                *)
 869                        test -n "$quiet" && return;;
 870                esac
 871                shift
 872                printf "%s" "$*"
 873                tput sgr0
 874                echo
 875                )
 876        }
 877else
 878        say_color() {
 879                test -z "$1" && test -n "$quiet" && return
 880                shift
 881                printf "%s\n" "$*"
 882        }
 883fi
 884
 885if test -z "$TEST_NO_CREATE_REPO"
 886then
 887        test_create_repo "$TRASH_DIRECTORY"
 888else
 889        mkdir -p "$TRASH_DIRECTORY"
 890fi
 891# Use -P to resolve symlinks in our working directory so that the cwd
 892# in subprocesses like git equals our $PWD (for pathname comparisons).
 893cd -P "$TRASH_DIRECTORY" || exit 1
 894
 895this_test=${0##*/}
 896this_test=${this_test%%-*}
 897if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 898then
 899        say_color info >&3 "skipping test $this_test altogether"
 900        skip_all="skip all tests in $this_test"
 901        test_done
 902fi
 903
 904# Provide an implementation of the 'yes' utility
 905yes () {
 906        if test $# = 0
 907        then
 908                y=y
 909        else
 910                y="$*"
 911        fi
 912
 913        while echo "$y"
 914        do
 915                :
 916        done
 917}
 918
 919# Fix some commands on Windows
 920case $(uname -s) in
 921*MINGW*)
 922        # Windows has its own (incompatible) sort and find
 923        sort () {
 924                /usr/bin/sort "$@"
 925        }
 926        find () {
 927                /usr/bin/find "$@"
 928        }
 929        sum () {
 930                md5sum "$@"
 931        }
 932        # git sees Windows-style pwd
 933        pwd () {
 934                builtin pwd -W
 935        }
 936        # no POSIX permissions
 937        # backslashes in pathspec are converted to '/'
 938        # exec does not inherit the PID
 939        test_set_prereq MINGW
 940        test_set_prereq NATIVE_CRLF
 941        test_set_prereq SED_STRIPS_CR
 942        test_set_prereq GREP_STRIPS_CR
 943        GIT_TEST_CMP=mingw_test_cmp
 944        ;;
 945*CYGWIN*)
 946        test_set_prereq POSIXPERM
 947        test_set_prereq EXECKEEPSPID
 948        test_set_prereq CYGWIN
 949        test_set_prereq SED_STRIPS_CR
 950        test_set_prereq GREP_STRIPS_CR
 951        ;;
 952*)
 953        test_set_prereq POSIXPERM
 954        test_set_prereq BSLASHPSPEC
 955        test_set_prereq EXECKEEPSPID
 956        ;;
 957esac
 958
 959( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 960test -z "$NO_PERL" && test_set_prereq PERL
 961test -z "$NO_PYTHON" && test_set_prereq PYTHON
 962test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 963test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 964
 965# Can we rely on git's output in the C locale?
 966if test -n "$GETTEXT_POISON"
 967then
 968        GIT_GETTEXT_POISON=YesPlease
 969        export GIT_GETTEXT_POISON
 970        test_set_prereq GETTEXT_POISON
 971else
 972        test_set_prereq C_LOCALE_OUTPUT
 973fi
 974
 975# Use this instead of test_cmp to compare files that contain expected and
 976# actual output from git commands that can be translated.  When running
 977# under GETTEXT_POISON this pretends that the command produced expected
 978# results.
 979test_i18ncmp () {
 980        test -n "$GETTEXT_POISON" || test_cmp "$@"
 981}
 982
 983# Use this instead of "grep expected-string actual" to see if the
 984# output from a git command that can be translated either contains an
 985# expected string, or does not contain an unwanted one.  When running
 986# under GETTEXT_POISON this pretends that the command produced expected
 987# results.
 988test_i18ngrep () {
 989        if test -n "$GETTEXT_POISON"
 990        then
 991            : # pretend success
 992        elif test "x!" = "x$1"
 993        then
 994                shift
 995                ! grep "$@"
 996        else
 997                grep "$@"
 998        fi
 999}
1000
1001test_lazy_prereq PIPE '
1002        # test whether the filesystem supports FIFOs
1003        case $(uname -s) in
1004        CYGWIN*)
1005                false
1006                ;;
1007        *)
1008                rm -f testfifo && mkfifo testfifo
1009                ;;
1010        esac
1011'
1012
1013test_lazy_prereq SYMLINKS '
1014        # test whether the filesystem supports symbolic links
1015        ln -s x y && test -h y
1016'
1017
1018test_lazy_prereq FILEMODE '
1019        test "$(git config --bool core.filemode)" = true
1020'
1021
1022test_lazy_prereq CASE_INSENSITIVE_FS '
1023        echo good >CamelCase &&
1024        echo bad >camelcase &&
1025        test "$(cat CamelCase)" != good
1026'
1027
1028test_lazy_prereq UTF8_NFD_TO_NFC '
1029        # check whether FS converts nfd unicode to nfc
1030        auml=$(printf "\303\244")
1031        aumlcdiar=$(printf "\141\314\210")
1032        >"$auml" &&
1033        case "$(echo *)" in
1034        "$aumlcdiar")
1035                true ;;
1036        *)
1037                false ;;
1038        esac
1039'
1040
1041test_lazy_prereq AUTOIDENT '
1042        sane_unset GIT_AUTHOR_NAME &&
1043        sane_unset GIT_AUTHOR_EMAIL &&
1044        git var GIT_AUTHOR_IDENT
1045'
1046
1047test_lazy_prereq EXPENSIVE '
1048        test -n "$GIT_TEST_LONG"
1049'
1050
1051test_lazy_prereq USR_BIN_TIME '
1052        test -x /usr/bin/time
1053'
1054
1055test_lazy_prereq NOT_ROOT '
1056        uid=$(id -u) &&
1057        test "$uid" != 0
1058'
1059
1060# On a filesystem that lacks SANITY, a file can be deleted even if
1061# the containing directory doesn't have write permissions, or a file
1062# can be accessed even if the containing directory doesn't have read
1063# or execute permissions, causing our tests that validate that Git
1064# works sensibly in such situations.
1065test_lazy_prereq SANITY '
1066        mkdir SANETESTD.1 SANETESTD.2 &&
1067
1068        chmod +w SANETESTD.1 SANETESTD.2 &&
1069        >SANETESTD.1/x 2>SANETESTD.2/x &&
1070        chmod -w SANETESTD.1 &&
1071        chmod -rx SANETESTD.2 ||
1072        error "bug in test sript: cannot prepare SANETESTD"
1073
1074        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1075        status=$?
1076
1077        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1078        rm -rf SANETESTD.1 SANETESTD.2 ||
1079        error "bug in test sript: cannot clean SANETESTD"
1080        return $status
1081'
1082
1083GIT_UNZIP=${GIT_UNZIP:-unzip}
1084test_lazy_prereq UNZIP '
1085        "$GIT_UNZIP" -v
1086        test $? -ne 127
1087'